#!/bin/bash
mkdir -p /nfsexport /nfsmnt
cp /etc/exports{,.back}
cat > /etc/exports <<EOF
/nfsexport *(rw,no_root_squash)
EOF
systemctl restart nfs-server || exit
cc copy_file_range.c -o /root/cfr || exit
mount -t nfs -o vers=4.2 localhost:/nfsexport/ /nfsmnt || exit
mount | grep nfsmnt
cd /nfsmnt
for i in 0 17 4095 4096 4097 ; do		  # in offset
	for j in 0 17 4095 4096 4097 ; do	  # out offset
		for k in 11 4095 4096 4097 ; do   # len
			echo ABCDEFGHIJKLMNOPQRSTUVWXYZ12345 > 1
			echo ABCDEFGHIJKLMNOPQRSTUVWXYZ12345 > 2
			sync
			/root/cfr 1 2 $i $j $k
		done
	done
done
cd
umount /nfsmnt
systemctl stop nfs-server
rm -f test.img
